﻿(function($) {
    if (typeof (playground) == "undefined") { playground = {}; } // add or create playground namespace

    playground.events = { // add events namespace
        init: function(e, gadget) { // add init method
            var q = $(".epi-gadgetContent", gadget.element); // save a query in a private varibale
            var log = function(text, e) { // create a local function using closures to access gadget
                if (typeof (console) != "undefined" && console.log) { console.log(text, e, gadget); } // log to firebug console if available
                q.after("<div title='" + gadget.id + ", " + new Date().toTimeString() + "'>" + text + "</div>"); // write just below the gadget window
            };

            // bind to available gadget events
            log("init", e);
            $(gadget.element).bind("epigadgetloaded", function(e, gadget) { log("epigadgetloaded", e); });
            $(gadget.element).bind("epigadgetvisibilitychanged", function(e, gadget) { log("epigadgetvisibilitychanged " + gadget.isVisible(), e); });
            $(gadget.element).bind("epigadgetinitmove", function(e, gadget) { log("epigadgetinitmove", e); });
            $(gadget.element).bind("epigadgetmove", function(e, gadget) { log("epigadgetmove", e); });
            $(gadget.element).bind("epigadgetsubmit", function(e, gadget) { log("epigadgetsubmit", e); });
            $(gadget.element).bind("epigadgetunload", function(e, gadget) { log("epigadgetunload", e); });
            $(gadget.element).bind("epigadgetremove", function(e, gadget) { log("epigadgetremove", e); });
            $(gadget.element).bind("epigadgeterror", function(e, args) { log("epigadgeterror", e); });
        }
    };

    // using this pattern helps keeping your privates private
})(epiJQuery);